(function (angular) {
    var module = angular.module('framework.UI.module',[]);

    module.controller('ModuleCardsController', moduleCardsController);

    moduleCardsController.$inject = ['$scope', 'rData', 'rNavTo','rAccessors', '$state', '$interval', '$timeout'];
    function moduleCardsController($scope, rData, rNavTo, rAccessors, $state, $interval, $timeout) {
        $scope.rawItems = rData;
        $scope.accessors = rAccessors;
        $scope.rNavTo = rNavTo;
        $scope.showScore = false;
        $scope.chosenGroup = null;
        $scope.cardLimit = 2;

        $scope.groups = {};
        rData = rData.sort(function(a,b){
        	var valA = rAccessors.Title(a), valB = rAccessors.Title(b);
        	if(valA < valB) {
        		return -1;
        	} else if (valA > valB){
        		return 1;
        	} else
        		return 0;
        });
        
        var i;

        for(i = 0; i < rData.length; i++) {
            var title = rAccessors.Group(rData[i]);
            if($scope.groups[title])
                $scope.groups[title].push(rData[i]);
            else 
                $scope.groups[title] = [rData[i]];
        }
    }

})(angular);